import { IAgent } from './defs';
import EventEmitter from './EventEmitter';
import Molecule from './Molecule';
export declare type AgentConfig = {
    molecule: Molecule;
    [key: string]: any;
};
declare class Agent implements IAgent {
    config: any;
    store?: any;
    emitter: EventEmitter;
    preventInit: boolean;
    constructor(config?: AgentConfig);
    readonly molecule: any;
    on(event: any, handler: any): void;
    off(event: any, handler: any): void;
    emit(event: any, ...args: any[]): void;
    getAgent(name: any): IAgent;
    prepare(): void;
    init(): void;
    clean(): void;
    validate(config: any): void;
    isDebug(): any;
    static factory(config?: object): ((molecule: Molecule) => any);
}
export default Agent;
