"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var EventEmitter_1 = require("./EventEmitter");
var Agent = (function () {
    function Agent(config) {
        this.config = {};
        this.preventInit = false;
        this.config = config;
        var configWithoutMolecule = Object.assign({}, config);
        delete configWithoutMolecule.molecule;
        this.validate(configWithoutMolecule);
        this.emitter = new EventEmitter_1.default({
            context: config.name,
            debug: config.debug,
        });
    }
    Object.defineProperty(Agent.prototype, "molecule", {
        get: function () {
            return this.config.molecule;
        },
        enumerable: true,
        configurable: true
    });
    Agent.prototype.on = function (event, handler) {
        this.emitter.on(event, handler);
    };
    Agent.prototype.off = function (event, handler) {
        this.emitter.off(event, handler);
    };
    Agent.prototype.emit = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        (_a = this.emitter).emit.apply(_a, [event].concat(args));
        var _a;
    };
    Agent.prototype.getAgent = function (name) {
        return this.molecule.getAgent(name);
    };
    Agent.prototype.prepare = function () { };
    Agent.prototype.init = function () { };
    Agent.prototype.clean = function () { };
    Agent.prototype.validate = function (config) { };
    Agent.prototype.isDebug = function () {
        return this.config.debug || this.molecule.debug;
    };
    Agent.factory = function (config) {
        var def = this;
        return function (molecule) {
            return new def(__assign({}, config, { molecule: molecule }));
        };
    };
    return Agent;
}());
exports.default = Agent;
//# sourceMappingURL=Agent.js.map