import * as BaseEventEmitter from 'eventemitter3';
export declare type Options = {
    context?: string;
    debug?: boolean | string;
    parent?: EventEmitter;
};
export declare type ObjectEvent = {
    name: string;
    validate?: (params) => void;
};
export declare type Event = string | symbol | ObjectEvent;
export default class EventEmitter extends BaseEventEmitter {
    options: Options;
    constructor(options?: Options);
    emit(event: Event, ...args: any[]): boolean;
    on(event: Event, handler: (...args: any[]) => void): this;
    once(event: Event, handler: (...args: any[]) => void): this;
    private logEmit(event, ...args);
    private logHandle(event, ...args);
    private logOn(event);
}
