"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseEventEmitter = require("eventemitter3");
var EventEmitter = (function (_super) {
    __extends(EventEmitter, _super);
    function EventEmitter(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    EventEmitter.prototype.emit = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (event && typeof event === 'object' && !!event.name) {
            if (event.validate) {
                (_a = event.validate).call.apply(_a, [null].concat(args));
            }
            event = event.name;
        }
        this.logEmit.apply(this, [event].concat(args));
        var result = _super.prototype.emit.apply(this, [event].concat(args));
        if (this.options.parent) {
            (_b = this.options.parent).emit.apply(_b, [event].concat(args));
        }
        return result;
        var _a, _b;
    };
    EventEmitter.prototype.on = function (event, handler) {
        var _this = this;
        if (typeof event === 'object' && !!event.name) {
            event = event.name;
        }
        var newHandler = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            _this.logHandle.apply(_this, [event].concat(args));
            return handler.apply(void 0, args);
        };
        this.logOn(event);
        return _super.prototype.on.call(this, event, newHandler);
    };
    EventEmitter.prototype.once = function (event, handler) {
        var _this = this;
        if (typeof event === 'object' && !!event.name) {
            event = event.name;
        }
        var newHandler = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            _this.logHandle.apply(_this, [event].concat(args));
            return handler.apply(void 0, args);
        };
        this.logOn(event);
        return _super.prototype.once.call(this, event, newHandler);
    };
    EventEmitter.prototype.logEmit = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var _a = this.options, context = _a.context, debug = _a.debug;
        if (debug) {
            context = context || 'anonymous';
            console.log.apply(console, ["[" + context + "] Emitted " + event + " with arguments: "].concat(args));
        }
    };
    EventEmitter.prototype.logHandle = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var _a = this.options, context = _a.context, debug = _a.debug;
        if (debug) {
            context = context || 'anonymous';
            console.log.apply(console, ["[" + context + "] Caught \"" + event + "\" with arguments: "].concat(args));
        }
    };
    EventEmitter.prototype.logOn = function (event) {
        var _a = this.options, context = _a.context, debug = _a.debug;
        if (debug) {
            context = context || 'anonymous';
            console.log("[" + context + "] Started listening to \"" + event + "\" event");
        }
    };
    return EventEmitter;
}(BaseEventEmitter));
exports.default = EventEmitter;
//# sourceMappingURL=EventEmitter.js.map