import EventEmitter from './EventEmitter';
import { MoleculeOptions } from './defs';
import Agent from './Agent';
import { ComponentRegistry } from './ComponentRegistry';
export default class Molecule {
    name: string;
    config: any;
    debug: boolean;
    agents: {
        [key: string]: Agent;
    };
    emitter: EventEmitter;
    store: any;
    registry: ComponentRegistry;
    parent?: Molecule;
    children: Molecule[];
    constructor(value: MoleculeOptions, parent?: Molecule);
    readonly root: any;
    init(): void;
    clean(): void;
    on(event: any, handler: any): void;
    off(event: any, handler: any): void;
    emit(event: any, ...args: any[]): void;
    deepmit(event: any, ...args: any[]): void;
    closest(name: string): any;
    getAgent(name: any): Agent;
    private storeAgents(_agents);
}
