"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var MoleculeContext_1 = require("./MoleculeContext");
var Molecule_1 = require("./Molecule");
var withs_1 = require("./withs");
var Molecule = (function (_super) {
    __extends(Molecule, _super);
    function Molecule(props) {
        var _this = _super.call(this, props) || this;
        var parent = null;
        if (props.molecule instanceof Molecule_1.default) {
            parent = props.molecule;
        }
        _this.molecule = new Molecule_1.default(props, parent);
        _this.molecule.init();
        return _this;
    }
    Molecule.prototype.componentWillUnmount = function () {
        this.molecule.clean();
    };
    Molecule.prototype.render = function () {
        var _this = this;
        var children = this.props.children;
        var results;
        if (typeof children === 'function') {
            results = children(this.molecule);
        }
        else {
            results = React.Children.map(children, function (child) {
                return React.cloneElement(child, {
                    molecule: _this.molecule,
                });
            });
        }
        return (React.createElement(MoleculeContext_1.default.Provider, { value: this.molecule }, results));
    };
    return Molecule;
}(React.Component));
exports.default = withs_1.withMolecule(Molecule);
//# sourceMappingURL=MoleculeWrap.js.map