"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Agent_1 = require("../Agent");
var mocha_1 = require("mocha");
var chai_1 = require("chai");
mocha_1.describe('Agent', function () {
    var MyAgent = (function (_super) {
        __extends(MyAgent, _super);
        function MyAgent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MyAgent.prototype.whoami = function () {
            return this.config.iam || 'coder';
        };
        return MyAgent;
    }(Agent_1.default));
    mocha_1.it('Should work directly', function () {
        var agent = new MyAgent({
            molecule: {},
        });
        chai_1.assert.equal('coder', agent.whoami());
    });
    mocha_1.it('Should work with factory', function () {
        var factory = MyAgent.factory({
            iam: 'code',
        });
        var agent = factory({});
        chai_1.assert.equal('code', agent.whoami());
    });
    mocha_1.it('Should properly get the molecule', function () {
        var factory = MyAgent.factory({
            iam: 'code',
        });
        var agent = factory({
            name: 'dummy',
        });
        chai_1.assert.equal('dummy', agent.molecule.name);
    });
});
//# sourceMappingURL=Agent.js.map