"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var EventEmitter_1 = require("../EventEmitter");
var mocha_1 = require("mocha");
var chai_1 = require("chai");
mocha_1.describe('EventEmitter', function () {
    mocha_1.it('Should work with on and smart event', function (done) {
        var emitter = new EventEmitter_1.default({
            context: 'test',
        });
        var Events = {
            DEMO: {
                name: 'demo',
            },
        };
        emitter.on(Events.DEMO, function () {
            done();
            emitter.removeAllListeners();
        });
        emitter.emit(Events.DEMO, 'Hello!');
    });
    mocha_1.it('Shuld throw error when validation does not work', function (done) {
        var emitter = new EventEmitter_1.default({
            context: 'test',
            debug: true,
        });
        var Events = {
            DEMO: {
                name: 'demo',
                validate: function () {
                    throw 'I am not allowing!';
                },
            },
        };
        try {
            emitter.emit(Events.DEMO);
        }
        catch (e) {
            chai_1.assert.isString(e);
            done();
        }
    });
});
//# sourceMappingURL=EventEmitter.js.map