import EventEmitter from './EventEmitter';
import Molecule from './Molecule';
import Agent from './Agent';
export declare type AgentDefinitionMap = {
    [key: string]: (molecule: Molecule) => Agent;
};
export declare type ComponentMap = {
    [component: string]: any;
};
export declare type MoleculeOptions = {
    config?: any;
    registry?: ComponentMap;
    store?: any;
    agents?: AgentDefinitionMap;
    name?: string;
    debug?: boolean;
};
export interface IAgent {
    emit(key: string, value: any): void;
    on(event: string, handler: () => void): void;
    off(event: string, handler: () => void): void;
    molecule: Molecule;
    emitter: EventEmitter;
    preventInit: boolean;
    init(): void;
    prepare(): void;
    clean(): void;
}
export declare type ComponentRegistryBlendOptions = {
    prefix?: string;
    throwOnCollisions?: boolean;
};
