"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var MoleculeWrap_1 = require("./MoleculeWrap");
function mole(optionsResolver) {
    return function (Component) {
        return function (props) {
            var options;
            if (typeof optionsResolver === 'object') {
                options = optionsResolver;
            }
            else if (typeof optionsResolver === 'function') {
                options = optionsResolver(props);
            }
            else {
                options = {};
            }
            return React.createElement(MoleculeWrap_1.default, __assign({}, options, { children: React.createElement(Component, props) }));
        };
    };
}
exports.default = mole;
//# sourceMappingURL=mole.js.map