"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var MoleculeContext_1 = require("./MoleculeContext");
var React = require("react");
function getDisplayName(WrappedComponent) {
    return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}
exports.withMolecule = function (WrappedComponent) {
    var WithMoleculeContainer = function (props) {
        return (React.createElement(MoleculeContext_1.default.Consumer, null, function (molecule) {
            return React.createElement(WrappedComponent, __assign({}, props, { molecule: molecule }));
        }));
    };
    WithMoleculeContainer.displayName = "WithMolecule(" + getDisplayName(WrappedComponent) + ")";
    return WithMoleculeContainer;
};
exports.withAgent = function (agentName, asName) {
    if (asName === void 0) { asName = 'agent'; }
    return function (WrappedComponent) {
        var WithAgentContainer = function (props) {
            return React.createElement(exports.withMolecule(function (_a) {
                var molecule = _a.molecule;
                var newProps = Object.assign({}, props, (_b = {},
                    _b[asName] = molecule.agents[agentName],
                    _b));
                return React.createElement(WrappedComponent, __assign({}, newProps, { molecule: molecule }));
                var _b;
            }));
        };
        WithAgentContainer.displayName = "WithAgent(" + getDisplayName(WrappedComponent) + ")";
        return WithAgentContainer;
    };
};
function WithAgent(_a) {
    var children = _a.children, agent = _a.agent;
    return React.createElement(exports.withAgent(agent)(function (_a) {
        var agent = _a.agent, molecule = _a.molecule;
        return children({ agent: agent, molecule: molecule });
    }));
}
exports.WithAgent = WithAgent;
function WithMolecule(_a) {
    var children = _a.children;
    return React.createElement(exports.withMolecule(function (_a) {
        var molecule = _a.molecule;
        return children(molecule);
    }));
}
exports.WithMolecule = WithMolecule;
//# sourceMappingURL=withs.js.map